<script setup lang="ts">
import { useReceiptStore } from '@/stores/receipt';
import { usePromotionStore } from '@/stores/promotion';

import { provide } from 'vue';
import { ref } from 'vue';
import type { Promotion } from '@/types/Promotion';
import { watch } from 'vue';

const receiptStore = useReceiptStore()
const promotionStore = usePromotionStore()
const promotion =ref<Promotion>(promotionStore.currentPromotion!)
const promotionName = ref('')
const cashText = ref()

const activeComponent = ref(1)
watch(promotion,(newValue)=>{
    promotionName.value = newValue.name
});

const dialogCash = ref(false)

function calChange(){
  const paInt = cashText.value = parseInt(cashText.value, 10);
  let cash = receiptStore.receipt.receivedAmount = paInt
  let total = receiptStore.receipt.total
  if(cash>=total){
    receiptStore.receipt.change = cash - total
  }else{
    receiptStore.receipt.receivedAmount = 0
    receiptStore.receipt.change = 0
    dialogCash.value = !dialogCash.value
  }
  clearTxtField()
}

function validateNumber(value:any) {
    const isValid = /^\d+$/.test(value);
    return isValid || "Please enter a number";
}



function promptpay(){
  const a = receiptStore.receipt.paymentType = 'promptpay'
  console.log(a);
  receiptStore.receipt.receivedAmount = receiptStore.receipt.total
  receiptStore.receipt.change = 0
  
}

function cashPay(){
  const a = receiptStore.receipt.paymentType = 'cash'
  console.log(a);
  
}

function clearTxtField(){
  cashText.value = '0'
}

</script>

<template>
  <v-container>
    <v-row>
      <v-col justify="center">
        <v-row no-gutters>
          <v-col cols="6">Subtotal:</v-col><v-col cols="6">{{ receiptStore.receipt?.totalBefore}} ฿</v-col>
          <v-col cols="6">Member Discount:</v-col><v-col cols="6">{{ (receiptStore.receipt.memberDiscount.toFixed(2)) }} ฿</v-col>
          <v-col cols="3">Promotion:</v-col>
          <v-col cols="9" v-if="promotionStore.currentPromotion">{{ promotionStore.currentPromotion.name }}</v-col>
          <v-col cols="7" v-else></v-col>
          
          <v-col cols="6">Promotion Discount:</v-col><v-col cols="6" v-if="promotionStore.currentPromotion">{{ receiptStore.receipt.promotionDiscount }} ฿</v-col>
          <v-col cols="6" v-else>0.00 ฿</v-col>
          <v-col cols="6">Total:</v-col><v-col cols="6">{{ receiptStore.receipt?.total}} ฿</v-col>
        </v-row>
      </v-col>
      <v-divider :thickness="2" class="border-opacity-100" vertical></v-divider>
      <v-col>
        <v-row class="align-center" no-gutters>
          <v-col cols="6"><v-btn elevation="2" block prepend-icon="mdi-cash" color="teal-accent-1" @click="receiptStore.changeComponent(1),cashPay()">CASH</v-btn ></v-col>
            <v-col cols="6"><v-btn elevation="2" block color="indigo-darken-4" prepend-icon="mdi-qrcode-scan" @click="receiptStore.changeComponent(2),promptpay()">PROMPTPAY</v-btn></v-col> 
        </v-row>

        <v-row no-gutters v-if="receiptStore.activeComponent === 1">
              <v-col cols="6"><p style="text-align: center;">Cash: {{ receiptStore.receipt.receivedAmount }} ฿</p></v-col><v-col cols="6">
              <v-text-field 
                density="compact" 
                v-model="cashText" 
                append-inner-icon="mdi-send" 
                type="number"
                label="Insert Cash"
                @click:append-inner="calChange()"
                @keyup.enter="calChange()"
                :rules="[validateNumber]"
                clearable>
              </v-text-field></v-col> 
              <v-col cols="6" style="text-align: center;">Change:</v-col><v-col cols="6">{{ (receiptStore.receipt.change.toFixed(2)) }} ฿</v-col>  
        </v-row>
        <v-row v-if="receiptStore.activeComponent === 2">
          <v-col cols="6" style="padding-left: 60px;">
            <div style="justify-content: center;align-self: center;">
              <v-img
                  :width="80"
                  :height="80"
                  aspect-ratio="1/1"
                  cover
                  :src="`./img/promptpay.png`"
              ></v-img>
            </div>
          </v-col>
          <v-col cols="6" align-self="center">Amout: {{ receiptStore.receipt.total }} ฿</v-col>
        </v-row>
      </v-col>
    </v-row>
  </v-container>

  <v-dialog v-model="dialogCash" width="250px">
    <template v-slot:default="{ isActive }">
    <v-card title="Warning">
      <v-card-text>
        Cash is Lower Than Total
      </v-card-text>

      <v-card-actions>
        <v-spacer></v-spacer>

        <v-btn
          text="Close"
          color="red"
          @click="isActive.value = false"
        ></v-btn>
      </v-card-actions>
    </v-card>
  </template>
  </v-dialog>
</template>